
#define PLAY_CELL( ptr0, the_player ) \
 \
	play_p = ptr0; \
	*(UBYTE*)*play_p++ = (UBYTE)the_player; \
 \
	for ( play_k = *play_p++; play_k ; play_k-- ) \
		*(UBYTE*)*play_p++ = (UBYTE)the_player;


#define UNPLAY_CELL( ptr0, the_enemy ) \
 \
	play_p = ptr0; \
	*(UBYTE*)*play_p++ = CODE_EMPTY; \
 \
	for ( play_k = *play_p++; play_k ; play_k-- ) \
		*(UBYTE*)*play_p++ = the_enemy;


#define DEF( X ) \
	int X( const int depth, void *curr_ptr, \
		const int the_player, const int the_enemy )

	DEF( do_scan_end_game )
	{
	void			*ptr1, *ptr2;
	UINT			*p, *p0;
	int				nb_poss, nb_took;
	int				coef, coef_best;

	/*--- Gener all the possibilities of game for the current player ---*/
	ptr1 = ptr2 = curr_ptr;
	nb_poss = do_build_possib( &ptr2, the_player, the_enemy );

	/*--- Count the number of cells analysed ---*/
	cnt += nb_poss;

	/*--- End of analyse if : (1) none player can play ---*/
	/*---                     (2) board is full        ---*/
	if ( !nb_poss )
		{

		ptr2 = curr_ptr;
		if ( !do_build_possib( &ptr2, the_enemy, the_player ) )
			return 0;

		ptr2 = curr_ptr;
		return -do_scan_end_game( depth+1, ptr2, the_enemy, the_player );

		}	// if

	/*--- Initialize coeficient ---*/
	coef_best = INT_MIN;

	/*--- For each possibility of play ---*/
	for ( p = (UINT*)ptr1, p++; p != ptr2; )
		{

		/*--- Play this position ---*/
		p0 = p++;
		PLAY_CELL( p0, the_player );
		nb_pawns[ the_player ] += ((nb_took = *p++) + 1);
		nb_pawns[ the_enemy ]  -= nb_took;

		/*--- Check all possibilities one level depther ---*/
		if ( nb_pawns[ CODE_WHITE ] + nb_pawns[ CODE_BLACK ] == 64 )
			{
			coef = nb_took;
			if ( f_refresh_time && (cnt%10000 == 1) )
				do_refresh_time();
			}
		else
			coef = nb_took - do_scan_end_game( depth+1, ptr2, the_enemy, the_player );
			
		/*--- Update coeficient ---*/
		if ( coef > coef_best )
			{
			coef_best = coef;
			if ( !depth )
				play_pos_xy = *p0;
			}	// if

		/*--- Unplay this position ---*/
		UNPLAY_CELL( p0, the_enemy );
		nb_pawns[ the_player ] -= (nb_took + 1);
		nb_pawns[ the_enemy ]  += nb_took;

		/*--- Next possibility for this player ---*/
		p += nb_took;
		
		}	// for (p)

	return coef_best;
	
	}	// do_scan_end_game
#undef DEF


#define DEF( X) static void X( const UBYTE the_player, const UBYTE the_enemy, \
							   WHERE_TO_PLAY *where_to_play )
	DEF( _do_end_game )
	{
	time_t		t1, t2;
	int			coef_best;

	/*--- Initial time ---*/
	time( &t1 );

	/*--- Refresh the time is player is the computer ---*/
	f_refresh_time = (the_player == code_computer) ? TRUE : FALSE;

	cnt = 0;
	coef_best = do_scan_end_game( 0, &possib[ 0 ], the_player, the_enemy );

	/*--- Fill the where-to-play structure ---*/
	time( &t2 );
	where_to_play->elapsed = (time_t) difftime( t2, t1 );
	if ( (where_to_play->coef_best = coef_best) == INT_MIN )
		where_to_play->x = where_to_play->y = -1;
	else
		{
		where_to_play->x = ((play_pos_xy - (UINT)board) / 10);
		where_to_play->y = ((play_pos_xy - (UINT)board) % 10);
		}
	where_to_play->cnt = cnt;

	}	// _do_end_game_...
#undef DEF
