/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <limits.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "phothello.h"
#include "abimport.h"
#include "proto.h"


static	int			cnt;

static	int			max_depth;

static	BOOL		f_refresh_time;

static	int			chosen_move;

/*--- Used only by PLAY_CELL and UNPLAY_CELL : OPTIMIZATION ([ebp...] slow!] ---*/
static	UINT	*play_p;
static	int		play_k;


int sort_scores_black( const SCORE_TO_SORT *s1, const SCORE_TO_SORT *s2 )
	{
	
	if ( s1->score > s2->score )
		return -1;
	else
		if ( s1->score < s2->score )
			return 1;
	return 0;
	
	}	// sort_scores_black


int sort_scores_white( const SCORE_TO_SORT *s1, const SCORE_TO_SORT *s2 )
	{
	
	if ( s1->score < s2->score )
		return -1;
	else
		if ( s1->score > s2->score )
			return 1;
	return 0;
	
	}	// sort_scores_white


/*--- Create the version w/o  tree ---*/
#include "_game.hc"


static void _do_game( const UBYTE the_player, const UBYTE the_enemy, 
	WHERE_TO_PLAY *where_to_play );


void do_game( const UBYTE the_player, const UBYTE the_enemy,
				  WHERE_TO_PLAY *where_to_play )
	{

	/*--- Select the max level ---*/
	max_depth = levels[ options.level-1 ][ options.strategy-1 ];
	if ( nb_pawns[ CODE_BLACK ] + nb_pawns[ CODE_WHITE ] >= 40 )
		max_depth++;

	/*--- Select the strategy ---*/
	switch (options.strategy)
		{
		case STRATEGY1 : pf_ponderation = _ponderation1; break;
		case STRATEGY2 : pf_ponderation = _ponderation2; break;
		case STRATEGY3 : pf_ponderation = _ponderation3; break;
		case STRATEGY4 : pf_ponderation = _ponderation4; break;
		case STRATEGY5 : pf_ponderation = _ponderation5; break;
		case STRATEGY6 : pf_ponderation = _ponderation6; break;
		}	// switch

	/*--- Call the game function ---*/
	_do_game( the_player, the_enemy, where_to_play );
	
	}	//	do_game
