/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <limits.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "phothello.h"
#include "abimport.h"
#include "proto.h"


static	int		note;
static	int		nb_poss;

static	UBYTE	b11;
static	UBYTE	b18;
static	UBYTE	b81;
static	UBYTE	b88;


#define TEST_CORNERS \
 \
	/*--- Bords occupes ? ---*/ \
	if ( b11 == CODE_BLACK )		note += 1000000; \
	else if ( b11 == CODE_WHITE )	note -= 1000000; \
	if ( b18 == CODE_BLACK )		note += 1000000; \
	else if ( b18 == CODE_WHITE )	note -= 1000000; \
	if ( b81 == CODE_BLACK )		note += 1000000; \
	else if ( b81 == CODE_WHITE )	note -= 1000000; \
	if ( b88 == CODE_BLACK )		note += 1000000; \
	else if ( b88 == CODE_WHITE )	note -= 1000000;


#define TEST_AROUND_CORNERS \
	 \
	/*--- Sous-bords occupes ? ---*/ \
	if ( !b11 ) \
		{ \
		if ( board[22] == CODE_BLACK )		note -= 100000;  \
		else if ( board[22] == CODE_WHITE )	note += 100000; \
		if ( board[12] == CODE_BLACK )		note -= 100;  \
		else if ( board[12] == CODE_WHITE )	note += 100;  \
		if ( board[21] == CODE_BLACK )		note -= 100;  \
		else if ( board[21] == CODE_WHITE )	note += 100;  \
		} \
	if ( !b18 ) \
		{ \
		if ( board[27] == CODE_BLACK )		note -= 100000;  \
		else if ( board[27] == CODE_WHITE )	note += 100000;  \
		if ( board[17] == CODE_BLACK )		note -= 100;  \
		else if ( board[17] == CODE_WHITE )	note += 100;  \
		if ( board[28] == CODE_BLACK )		note -= 100;  \
		else if ( board[28] == CODE_WHITE )	note += 100;  \
		} \
	if ( !b81 ) \
		{ \
		if ( board[72] == CODE_BLACK )		note -= 100000;  \
		else if ( board[72] == CODE_WHITE )	note += 100000;  \
		if ( board[71] == CODE_BLACK )		note -= 100;  \
		else if ( board[71] == CODE_WHITE )	note += 100;  \
		if ( board[82] == CODE_BLACK )		note -= 100;  \
		else if ( board[82] == CODE_WHITE )	note += 100;  \
		} \
	if ( !b88 ) \
		{ \
		if ( board[77] == CODE_BLACK )		note -= 100000;  \
		else if ( board[77] == CODE_WHITE )	note += 100000;  \
		if ( board[78] == CODE_BLACK )		note -= 100;  \
		else if ( board[78] == CODE_WHITE )	note += 100;  \
		if ( board[87] == CODE_BLACK )		note -= 100;  \
		else if ( board[87] == CODE_WHITE )	note += 100;  \
		}
	

/*--- Strategy #1 : Juste take care of corners and sub-corners ---*/
int _ponderation1( const int the_player, const int the_enemy )
	{

	b11 = board[ 11 ];
	b18 = board[ 18 ];
	b81 = board[ 81 ];
	b88 = board[ 88 ];

	note = 0;
	TEST_CORNERS
	TEST_AROUND_CORNERS
	
	/*--- Done ---*/
	return note;
	
	}	// _ponderation1


/*--- Strategy #2 : Take care of corners and sub-corners AND 
	  Computer tries to maximise his number of pawns		 ---*/
int _ponderation2( const int the_player, const int the_enemy )
	{

	b11 = board[ 11 ];
	b18 = board[ 18 ];
	b81 = board[ 81 ];
	b88 = board[ 88 ];

	note = nb_pawns[ CODE_BLACK ] - nb_pawns[ CODE_WHITE ];
	TEST_CORNERS
	TEST_AROUND_CORNERS
	
	/*--- Done ---*/
	return note;
	
	}	// _ponderation2


/*--- Strategy #3 : Take care of corners and sub-corners AND 
	  Computer tries to minimise his number of pawns		 ---*/
int _ponderation3( const int the_player, const int the_enemy )
	{

	b11 = board[ 11 ];
	b18 = board[ 18 ];
	b81 = board[ 81 ];
	b88 = board[ 88 ];

	note = nb_pawns[ CODE_WHITE ] - nb_pawns[ CODE_BLACK ];
	TEST_CORNERS
	TEST_AROUND_CORNERS
	
	/*--- Done ---*/
	return note;
	
	}	// _ponderation3


int _ponderation4( const int the_player, const int the_enemy )
	{

	b11 = board[ 11 ];
	b18 = board[ 18 ];
	b81 = board[ 81 ];
	b88 = board[ 88 ];

	/*--- Gener all the possibilities of game for the next player ---*/
	nb_poss = nb_possib( the_enemy, the_player );
	if ( the_player == CODE_BLACK )	note = -nb_poss;
	else							note = nb_poss;

	TEST_CORNERS
	TEST_AROUND_CORNERS
	
	/*--- Done ---*/
	return note;
	
	}	// _ponderation4


#define EDGE( edge_dir, pp1, pp2 )  \
  \
	if (edge_dir==0x00100000 || edge_dir==0x00000100)		note += 200;  \
	else if (edge_dir==0x00100100 )							note += 600;  \
	else if (edge_dir==0x00010000 || edge_dir==0x00001000)	note += 30;  \
	else if (edge_dir==0x00011000)							note += 90;  \
	else if (edge_dir==0x00111000 || edge_dir==0x00011100)	note += 1000;  \
	else if (edge_dir==0x00102000 || edge_dir==0x00020100)	note += 20;  \
	else if (edge_dir==0x00110200 || edge_dir==0x00201100)	note += 15;  \
	else if (edge_dir==0x00111100)  \
		{  \
		switch( board[pp1] )  \
			{  \
			case CODE_EMPTY :  \
				switch ( board[pp2] )  \
					{  \
					case CODE_EMPTY	: note += 5000; break;  \
					case CODE_BLACK : note += 2500; break;  \
					case CODE_WHITE : note += 7500; break;  \
					}  \
				break;  \
			case CODE_BLACK :  \
				switch ( board[pp2] )  \
					{  \
					case CODE_EMPTY	: note += 2500; break;  \
					case CODE_BLACK : note += 1250; break;  \
					case CODE_WHITE : note += 1500; break;  \
					}  \
				break;  \
			case CODE_WHITE :  \
				switch ( board[pp2] )  \
					{  \
					case CODE_EMPTY	: note += 7500; break;  \
					case CODE_BLACK : note += 1500; break;  \
					case CODE_WHITE : note += 15000; break;  \
					}  \
				break;  \
			}  \
		}  \
  \
	if (edge_dir==0x00200000 || edge_dir==0x00000200)		note -= 200;  \
	else if (edge_dir==0x00200200 )							note -= 600;  \
	else if (edge_dir==0x00020000 || edge_dir==0x00002000)	note -= 30;  \
	else if (edge_dir==0x00022000)							note -= 90;  \
	else if (edge_dir==0x00222000 || edge_dir==0x00022200)	note -= 1000;  \
	else if (edge_dir==0x00201000 || edge_dir==0x00010200)	note -= 20;  \
	else if (edge_dir==0x00220100 || edge_dir==0x00102200)	note -= 15;  \
	else if (edge_dir==0x00222200)  \
		{  \
		switch( board[pp1] )  \
			{  \
			case CODE_EMPTY :  \
				switch ( board[pp2] )  \
					{  \
					case CODE_EMPTY	: note -= 5000; break;  \
					case CODE_WHITE : note -= 2500; break;  \
					case CODE_BLACK : note -= 7500; break;  \
					}  \
				break;  \
			case CODE_BLACK :  \
				switch ( board[pp2] )  \
					{  \
					case CODE_EMPTY	: note -= 2500; break;  \
					case CODE_WHITE : note -= 1250; break;  \
					case CODE_BLACK : note -= 1500; break;  \
					}  \
				break;  \
			case CODE_WHITE :  \
				switch ( board[pp2] )  \
					{  \
					case CODE_EMPTY	: note -= 7500; break;  \
					case CODE_WHITE : note -= 1500; break;  \
					case CODE_BLACK : note -= 15000; break;  \
					}  \
				break;  \
			} \
		}

int _ponderation5( const int the_player, const int the_enemy )
	{

	b11 = board[ 11 ];
	b18 = board[ 18 ];
	b81 = board[ 81 ];
	b88 = board[ 88 ];

	/*--- Edges ---*/
	code_edges();
	note = 0;
	EDGE( edge_north, 23, 26 )
	EDGE( edge_east,  37, 67 )
	EDGE( edge_south, 76, 73 )
	EDGE( edge_west,  62, 32 )

	TEST_CORNERS
	TEST_AROUND_CORNERS
	
	/*--- Done ---*/
	return note;
	
	}	// _ponderation5


int _ponderation6( const int the_player, const int the_enemy )
	{

	b11 = board[ 11 ];
	b18 = board[ 18 ];
	b81 = board[ 81 ];
	b88 = board[ 88 ];

	/*--- Edges codage ---*/
	code_edges();
	note = 0;
	EDGE( edge_north, 23, 26 )
	EDGE( edge_east,  37, 67 )
	EDGE( edge_south, 76, 73 )
	EDGE( edge_west,  62, 32 )

	/*--- Gener all the possibilities of game for the next player ---*/
	nb_poss = nb_possib( the_enemy, the_player );
	if ( the_player == CODE_BLACK )	note -= nb_poss;
	else							note += nb_poss;

	TEST_CORNERS
	TEST_AROUND_CORNERS
	
	/*--- Done ---*/
	return note;
	
	}	// _ponderation6
