/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "phothello.h"
#include "abimport.h"
#include "proto.h"


int
about_setup( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	link_instance = link_instance, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Show the version number and the date of the software ---*/
	setString( ABW_about_version, "Version %d.%d.%c (%04d/%02d/%02d)",
		(VERSION_NB >> 16), (VERSION_NB >> 8) & 0xFF, (VERSION_NB & 0xFF) + 'a',
		(VERSION_DATE >> 16) + 1998, (VERSION_DATE >> 8) & 0xFF, (VERSION_DATE & 0xFF) );

	/*--- Set the Position/Size of the window if given in the .ini file ---*/
	readandset_cfg_szpos( "About window", ABW_about );

	return( Pt_CONTINUE );

	}	// about_setup


int
about_destroyed( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Save position and dimension of this window into the config (life.ini) file ---*/
	save_posdim_in_config_file( "About window", ABW_about );

	/*--- Dialog not mounted ---*/
	ABW_about = NULL;

	return( Pt_CONTINUE );

	}	// about_destroyed
