
/* ../abmain.c */
void main ( int argc , char *argv []);

/* ../about.c */
int about_setup ( PtWidget_t *link_instance , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int about_destroyed ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../game.c */
int file_load_game ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int file_save_game ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
void init_new_game ( const BOOL f_draw , const BOOL f_reset_history );
int file_new_game ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
void update_config_file ( void );
int readandset_cfg_szpos ( char *section , PtWidget_t *wgt );
int save_posdim_in_config_file ( char *section , PtWidget_t *wgt );
int read_cfg_options ( void );
int file_exit ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../gridcell.c */
int gridcell_activate ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int gridcell_boundary ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../help.c */
int help_about ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int help_rules ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../history_selection.c */
int history_selection ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../options.c */
int options_changeside ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int options_settings ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int options_suggestmove ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../phothello.c */
int phothello_setup ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int phothello_realized ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
void computer_play ( WHERE_TO_PLAY *where_to_play , const UBYTE the_player , const UBYTE the_enemy , const BOOL f_suggest );
int phothello_btn_computer_turn ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int phothello_btn_human_pass ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int phothello_btn_human_cancel ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int phothello_btn_computer_pass ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int phothello_menubar_realized ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int diag_end_game ( void );
int phothello_destroyed ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../phothello_init.c */
void do_refresh_time ( void );
int refreshTime_handler ( void *data , pid_t pid , void *msg , ushort_t size );
void start_count_time ( const UBYTE color );
void stop_count_time ( void );
void slog ( const char *fmt , ...);
int phothello_init ( int argc , char *argv []);

/* ../rules.c */
int rules_setup ( PtWidget_t *link_instance , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int rules_destroyed ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int rules_resize ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../settings.c */
int settings_setup ( PtWidget_t *link_instance , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int settings_destroyed ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int settings_ok ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../utils.c */
int message ( const char *title , const char *fmt , ...);
void setString ( const PtWidget_t *wgt , const char *fmt , ...);
void getString ( const PtWidget_t *wgt , char *string );
void getPos ( const PtWidget_t *wgt , int *x , int *y );
void setPos ( const PtWidget_t *wgt , const int x , const int y );
void movePos ( const PtWidget_t *wgt , const int dx , const int dy );
void setBtn ( const PtWidget_t *wgt , const BOOL state );
BOOL isBtnSet ( const PtWidget_t *wgt );
void enableBtn ( const PtWidget_t *wgt , const BOOL state );
int ghostBtn ( const PtWidget_t *wgt , const BOOL state );
void selectableBtn ( const PtWidget_t *wgt , const BOOL state );
void setCursorColor ( const PtWidget_t *wgt , const PgColor_t color );
void setCursorType ( const PtWidget_t *wgt , int type );
void setBotBorderColor ( const PtWidget_t *wgt , const PgColor_t color );
void addListItem ( const PtWidget_t *wgt , const char *fmt , ...);
void selItemSelectedList ( const PtWidget_t *wgt , const int item_no );
int getItemSelectedList ( const PtWidget_t *wgt );
int getItemsCountList ( const PtWidget_t *wgt );
char *getItemList ( const PtWidget_t *wgt , const int item_no );
void setGauge_MinMax ( const PtWidget_t *wgt , const int vmin , const int vmax , const int vcurr );
int getGauge_value ( const PtWidget_t *wgt );
void setGauge_value ( const PtWidget_t *wgt , const int value );
void window_focus ( PtWidget_t *wgt );
int getInt ( const PtWidget_t *wgt );
void setInt ( const PtWidget_t *wgt , const int val );
void getDim ( const PtWidget_t *wgt , USHORT *w , USHORT *h );
void setDim ( const PtWidget_t *wgt , const int w , const int h );
int blockWindow ( const PtWidget_t *wgt , const BOOL state );
int busyWindow ( const PtWidget_t *wgt , const BOOL state );
void get_rel_possiz_window ( PtWidget_t *wgt , int *x , int *y , int *w , int *h );
void set_possiz_window ( PtWidget_t *wgt , const int x , const int y , const int w , const int h );

/* ../phutils.c */
void compute_nb_pawns ( const BOOL show );
void draw_pawn ( const int x , const int y , const int code_pawn );
void draw_complete_board ( void );
int show_poss_play_cursor ( const UBYTE cplayer , const UBYTE cenemy );
void noshow_poss_play_cursor ( void );
char *str_nb ( const int nb );

/* ../_ponderation.c */
int _ponderation1 ( const int the_player , const int the_enemy );
int _ponderation2 ( const int the_player , const int the_enemy );
int _ponderation3 ( const int the_player , const int the_enemy );
int _ponderation4 ( const int the_player , const int the_enemy );
int _ponderation5 ( const int the_player , const int the_enemy );
int _ponderation6 ( const int the_player , const int the_enemy );

/* ../_game.c */
int sort_scores_black ( const SCORE_TO_SORT *s1 , const SCORE_TO_SORT *s2 );
int sort_scores_white ( const SCORE_TO_SORT *s1 , const SCORE_TO_SORT *s2 );
void do_game ( const UBYTE the_player , const UBYTE the_enemy , WHERE_TO_PLAY *where_to_play );

/* ../_end_game.c */
void do_end_game ( const UBYTE the_player , const UBYTE the_enemy , WHERE_TO_PLAY *where_to_play );

/* ../do_build_possib.asm */

/* ../nb_possib.asm */

/* ../code_edges.asm */
