/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <process.h>
#include <sys/types.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "phothello.h"
#include "abimport.h"
#include "proto.h"


int
file_load_game( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
static	PtFileSelectionInfo_t	infos;
static	BOOL					first = TRUE;
		char					root_dir[ 200], fname[ 300 ];
		FILE					*fp;
		char					_node[ _MAX_NODE + 1 ], _dir[ _MAX_DIR + 1 ],
								_fname[ _MAX_FNAME + 1 ], _ext[ _MAX_EXT + 1 ];
		UBYTE					player, enemy;
		char					line[ 80 ];
		int						len;
		int						x, y;
		void					*ptr1, *ptr2;
		UINT					*p;
		void					*possib[ 60 ];
		int						nb_poss, nb_took;
		int						k;
		BOOL					valid_move;
		int						cnt;
		char					buff[ 200 ];
		char					*items[ 1 ];
		PtArg_t					args[ 1 ];
		unsigned 				*visible_count, nb_items, top_item_pos;

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Initialize infos results ---*/
	if ( first )
		{
		memset( &infos, 0, sizeof( infos ) );
		first = FALSE;
		}

	/*--- File dialog selection ---*/
	getcwd( root_dir, sizeof( root_dir ) - 1 );
	if ( PtFileSelection( NULL, NULL, "Load a game", root_dir, "*.oth",
		"&Load", "&Cancel", "ndk", &infos,
		Pt_FSDIALOG_NO_FCHECK | Pt_FSDIALOG_NO_UP_BUTTON ) == -1 )
		return( Pt_CONTINUE );

	/*--- Cancel ? ---*/
	if ( infos.ret == Pt_FSDIALOG_BTN2 )
		return( Pt_CONTINUE );

	/*--- Open the file ---*/
	if ( (strlen( infos.fspec ) >= 2) && (infos.fspec[ 0 ] == '*') )
		sprintf( fname, "%s.%s", infos.path, &infos.fspec[ 1 ] );
	else
		sprintf( fname, "%s%s", infos.path, infos.fspec );
	if ( (fp = fopen( infos.path, "r" )) == NULL )	
		return( Pt_CONTINUE );

	/*--- Reset the board ---*/
	init_new_game( TRUE, TRUE );
	
	/*--- Read each line of the file ---*/
	player = CODE_BLACK;
	enemy  = CODE_WHITE;
	busyWindow( ABW_phothello, TRUE );
	PtHold();
	for ( cnt = 0; ; )
		{

		/*--- Read a new line ---*/
		if ( !fgets( line, sizeof( line ) - 1, fp ) )
			break;
		if ( ((len = strlen( line )) > 0) && (line[ len-1 ] == '\n') )
			line[ len-1 ] = 0;

		/*--- Get the position ---*/
		if ( !strcmp( line, "" ) )
			continue;
		strupr( line );
		if ( (line[0] >= 'A') && (line[0] <= 'H') &&
			 (line[1] >= '1') && (line[1] <= '8') )
			{
			x = (line[1] - '0');
			y = (line[0] - '@');
			}
		else if ( (line[1] >= 'A') && (line[1] <= 'H') &&
				  (line[0] >= '1') && (line[0] <= '8') )
			{
			x = (line[0] - '0');
			y = (line[1] - '@');
			}
		else
			{
			message( "Unable to decode line: '%s'\n", line );
			fclose( fp );
			PtRelease();
			busyWindow( ABW_phothello, FALSE );
			init_new_game( TRUE, TRUE );
			return( Pt_CONTINUE );
			}

		/*--- Generate all the possible move ---*/
		ptr1 = ptr2 = &possib[ 0 ];
		if ( (nb_poss = do_build_possib( &ptr2, player, enemy )) == 0 )
			{
			player = (CODE_BLACK + CODE_WHITE) - player;
			enemy  = (CODE_BLACK + CODE_WHITE) - enemy;
			ptr1 = ptr2 = &possib[ 0 ];
			if ( (nb_poss = do_build_possib( &ptr2, player, enemy )) == 0 )
				{
				message( "Error, can't play at position %s\n", line );
				fclose( fp );
				PtRelease();
				busyWindow( ABW_phothello, FALSE );
				init_new_game( TRUE, TRUE );
				return( Pt_CONTINUE );
				}
			}	// if

		/*--- Is-it a valid move ? ---*/
		for ( valid_move = FALSE, p = (UINT*)ptr1, p++; p != ptr2; )
			{
			if ( (UBYTE*)*p++ == &board[ XY(x, y)] )
				{
				valid_move = TRUE;
				break;
				}
			nb_took = *p++;
			p += nb_took;
			}	// for (p)
		if ( !valid_move )
			{
			message( "Error, position %s not valid\n", line );
			fclose( fp );
			PtRelease();
			busyWindow( ABW_phothello, FALSE );
			init_new_game( TRUE, TRUE );
			return( Pt_CONTINUE );
			}

		/*--- Play this new move ---*/
		board[ XY(x, y) ] = player;
		for ( nb_took = *p++, k = 0; k < nb_took; k++ )
			*(UBYTE*)*p++ = player;

		/*--- Update the widget list 'History' ---*/
		sprintf( buff, "%2d: %s : %c%d",
			cnt+1,
			lib_colors[ player ],
			y + '@', x );
		items[ 0 ] = buff;
		PtListAddItems( ABW_phothello_history, items, 1, 0 );

		/*--- Next player ---*/
		player = (CODE_BLACK + CODE_WHITE) - player;
		enemy  = (CODE_BLACK + CODE_WHITE) - enemy;
		color_to_play = player;
		cnt++;

		}	// for (cnt)

	/*--- Close the file ---*/
	fclose( fp );

	/*--- Set the current directory ---*/
	_splitpath( infos.path, _node, _dir, _fname, _ext );
	chdir( _dir );

	/*--- Selection of the last element of the history list ---*/
	selItemSelectedList( ABW_phothello_history, getItemsCountList( ABW_phothello_history ) );
	
	/*--- Make this last element visible ---*/
	PtSetArg( &args[ 0 ], Pt_ARG_VISIBLE_COUNT, &visible_count, 0 );
	PtGetResources( ABW_phothello_history, 1, args );
	nb_items = getItemsCountList( ABW_phothello_history );
	top_item_pos = nb_items - *visible_count;
	PtSetArg( &args[ 0 ], Pt_ARG_TOP_ITEM_POS, top_item_pos, 0 );
	PtSetResources( ABW_phothello_history, 1, args );
	
	/*--- Redraw the board ---*/
	draw_complete_board();
	compute_nb_pawns( TRUE );

	/*--- Done ---*/
	PtRelease();
	busyWindow( ABW_phothello, FALSE );
	return( Pt_CONTINUE );

	}	// file_load_game


int
file_save_game( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
static	PtFileSelectionInfo_t	infos;
static	BOOL					first = TRUE;
		char					root_dir[ 200], fname[ 300 ];
		FILE					*fp;
		char					_node[ _MAX_NODE + 1 ], _dir[ _MAX_DIR + 1 ],
								_fname[ _MAX_FNAME + 1 ], _ext[ _MAX_EXT + 1 ];
		int						n;
		int						hist_sz;
		char					hist_item[ 80 ];

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Initialize infos results ---*/
	if ( first )
		{
		memset( &infos, 0, sizeof( infos ) );
		first = FALSE;
		}

	/*--- File dialog selection ---*/
	getcwd( root_dir, sizeof( root_dir ) - 1 );
	if ( PtFileSelection( NULL, NULL, "Save current game", root_dir, "*.oth",
		"&Save", "&Cancel", "ndk", &infos,
		Pt_FSDIALOG_NO_FCHECK | Pt_FSDIALOG_NO_UP_BUTTON ) == -1 )
		return( Pt_CONTINUE );

	/*--- Cancel ? ---*/
	if ( infos.ret == Pt_FSDIALOG_BTN2 )
		return( Pt_CONTINUE );

	/*--- Set the current directory ---*/
	_splitpath( infos.path, _node, _dir, _fname, _ext );
	if ( chdir( _dir ) == -1 )
		return( Pt_CONTINUE );

	/*--- Open the file ---*/
	if ( !strcmp( _ext, "" ) )
		strcpy( _ext, ".oth" );
	_makepath( fname, _node, _dir, _fname, _ext );
	if ( (fp = fopen( fname, "w" )) == NULL )	
		return
			message( "Save the current game", "%s\nError %d saving file.", fname, errno, NULL ),
			fclose( fp ),
			Pt_CONTINUE;
	hist_sz = getItemsCountList( ABW_phothello_history );
	for ( n = 0; n < hist_sz; n++ )
		{
		strcpy( hist_item, getItemList( ABW_phothello_history, n+1 ) );
		fprintf( fp, "%c%c\n", hist_item[ 12 ], hist_item[ 13 ] );
		}
	fclose( fp );

	return( Pt_CONTINUE );

	}	// file_save_game


void init_new_game( const BOOL f_draw, const BOOL f_reset_history )
	{
	int		k;
	int		x, y;

	/*--- By default, computer has black, play has white ---*/
	code_computer = CODE_WHITE;
	code_human    = CODE_BLACK;
	color_to_play = CODE_BLACK;			// Next color to play

	/*--- Dimiss all possible messages ---*/
	PtUnrealizeWidget( ABW_phothello_btn_human_pass );
	PtUnrealizeWidget( ABW_phothello_btn_human_cancel );
	PtUnrealizeWidget( ABW_phothello_btn_human_turn );
	PtUnrealizeWidget( ABW_phothello_btn_computer_pass );
	PtUnrealizeWidget( ABW_phothello_btn_computer_turn );

	/*--- Initialise the starting time (reference) ---*/
	time( &start_refreshTime );

	/*--- Initialize the board ---*/
	for ( k = 0; k < 9; k++ )
		board[ XY( 0, k ) ] =
		board[ XY( k, 9 ) ] = 
		board[ XY( 9, 9 - k ) ] =
		board[ XY( 9 - k, 0 ) ] = CODE_AROUND;
	for ( x = 1; x <= 8; x++ )
		for ( y = 1; y <= 8; y++ )
			board[ XY( x, y ) ] = CODE_EMPTY;
	board[ XY( 4, 4 ) ] = CODE_WHITE;
	board[ XY( 4, 5 ) ] = CODE_BLACK;
	board[ XY( 5, 4 ) ] = CODE_BLACK;
	board[ XY( 5, 5 ) ] = CODE_WHITE;

	/*--- Update the infos on the window ---*/
	if ( code_computer == CODE_BLACK )
		{
		setString( ABW_phothello_who_black, "Computer:" );
		setString( ABW_phothello_who_white, "Player:" );
		}	// if
	else
		{
		setString( ABW_phothello_who_black, "Player:" );
		setString( ABW_phothello_who_white, "Computer:" );
		}	// else

	/*--- Cumul time played by each color ---*/
	time( &t_start );				// Time when player starts thinking
	ctime_black = ctime_white = 0;
	setString( ABW_phothello_ctime_black, "%02d:%02d",
		ctime_black / 60, ctime_black % 60 );
	setString( ABW_phothello_ctime_white, "%02d:%02d",
		ctime_white / 60, ctime_white % 60 );

	/*--- Draw the complete board ---*/
	if ( f_draw )
		draw_complete_board();
	compute_nb_pawns( f_draw );

	/*--- Show the possibilities of the player ---*/
	if ( f_draw )
		show_poss_play_cursor( code_human, code_computer );

	/*--- Reset history of the game ---*/
	if ( f_reset_history )
		PtListDeleteAllItems( ABW_phothello_history );	

	/*--- Reset msg ---*/
	setString( ABW_phothello_msg, "" );
			
	/*--- 'This is your turn' ---*/
	PtRealizeWidget( ABW_phothello_btn_human_turn );
	PtContainerGiveFocus( ABW_phothello_btn_human_turn, NULL );

	}	// init_new_game


int
file_new_game( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Initializations prior to begin a new game ---*/
	init_new_game( TRUE, TRUE );

	return( Pt_CONTINUE );

	}	// file_new_game


void update_config_file( void )
	{
	char		temp[ 100 ];
	int			x, y, w, h;

	/*--- Open the configuration file ---*/	
	if ( PxConfigOpen( ini_fname, PXCONFIG_WRITE ) == Pt_FALSE )
		return;

	/*--- Windows Size and Position ---*/	
	PxConfigSection( CFG_SECTION_WINSZPOS );

	/*--- Size and position ---*/
	get_rel_possiz_window( ABW_phothello, &x, &y, &w, &h );
	sprintf( temp, "%d,%d,%d,%d", x, y, w, h );
	PxConfigWriteString( CFG_SECTION_WINSZPOS, "Phothello window", PXCONFIG_FMT_STRING, temp );

	/*--- Options ---*/	
	PxConfigSection( CFG_SECTION_OPTIONS );
	PxConfigWriteInt( CFG_SECTION_OPTIONS, "Level", PXCONFIG_FMT_INT_DECIMAL,
		options.level );
	PxConfigWriteInt( CFG_SECTION_OPTIONS, "Strategy", PXCONFIG_FMT_INT_DECIMAL,
		options.strategy );

	/*--- Close the configuration file ---*/
	PxConfigClose();

	}	// update_config_file


int readandset_cfg_szpos( char *section, PtWidget_t *wgt )
	{
	char		temp[ 100 ];
	int			x, y, w, h;

	/*--- Open the configuration file ---*/	
	if ( PxConfigOpen( ini_fname, PXCONFIG_READ ) == Pt_FALSE )
		return -1;

	/*--- Windows Size and Position ---*/	
	PxConfigSection( CFG_SECTION_WINSZPOS );
	if ( PxConfigReadString( CFG_SECTION_WINSZPOS, section, "", 
		temp, sizeof( temp ) - 1 ) == NULL )
		{
		PxConfigClose();
		return -1;
		}
	if ( sscanf( temp, "%d,%d,%d,%d", &x, &y, &w, &h ) != 4 )
		{
		PxConfigClose();
		return -1;
		}

	/*--- Close the configuration file ---*/
	PxConfigClose();

	/*--- Set the original dim. and pos. of the window, realtive to the current console  ---*/
	set_possiz_window( wgt, x, y, w, h );
	
	return 0;
	
	}	// read_cfg_szpos_zoom


int save_posdim_in_config_file( char *section, PtWidget_t *wgt )
	{
	char		temp[ 100 ];
	int			x, y, w, h;

	/*--- Open the configuration file ---*/	
	if ( PxConfigOpen( ini_fname, PXCONFIG_WRITE ) == Pt_FALSE )
		return -1;

	/*--- Windows Size and Position ---*/	
	PxConfigSection( CFG_SECTION_WINSZPOS );
	get_rel_possiz_window( wgt, &x, &y, &w, &h );
	sprintf( temp, "%d,%d,%d,%d", x, y, w, h );
	PxConfigWriteString( CFG_SECTION_WINSZPOS, section, PXCONFIG_FMT_STRING, temp );

	/*--- Close the configuration file ---*/
	PxConfigClose();

	return 0;
	
	}	// save_posdim_in_config_file


int read_cfg_options( void )
	{
	int		status;

	/*--- Open the configuration file ---*/	
	if ( (status = PxConfigOpen( ini_fname, PXCONFIG_READ )) == Pt_FALSE )
		if ( PxConfigOpen( ini_fname, PXCONFIG_WRITE ) == Pt_FALSE )
			return -1;

	/*--- Options: Level ---*/	
	PxConfigReadInt( CFG_SECTION_OPTIONS, "Level", 3,
		&options.level );
	PxConfigReadInt( CFG_SECTION_OPTIONS, "Strategy", 4,
		&options.strategy );

	/*--- Options: Computer's turn confirmation ---*/
	#define GET_YESNO( label, var ) \
		PxConfigSection( CFG_SECTION_OPTIONS ); \
		PxConfigReadString( CFG_SECTION_OPTIONS, label, "no", temp, sizeof( temp ) - 1 ); \
		var = (!stricmp( temp, "yes" )) ? TRUE : FALSE;

	/*--- Close the configuration file ---*/
	PxConfigClose();
	return status;
	
	}	// read_cfg_options


int
file_exit( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Destroy others windows ---*/
	PtDestroyWidget( ABW_phothello );
	if ( ABW_settings )
		PtDestroyWidget( ABW_settings );
	if ( ABW_rules )
		PtDestroyWidget( ABW_rules );
	if ( ABW_about )
		PtDestroyWidget( ABW_about );

	/*--- Now exit the application ---*/
	exit( 0 );

	return( Pt_CONTINUE );

	}	// file_exit
