/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "phothello.h"
#include "abimport.h"
#include "proto.h"


int
history_selection( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	PtListCallback_t	*infos = (PtListCallback_t *) cbinfo->cbdata;
	UBYTE				player, enemy;
	int					x, y;
	void				*ptr1, *ptr2;
	UINT				*p;
	void				*possib[ 256 ];
	int					nb_poss, nb_took;
	int					k;
	BOOL				valid_move;
	int					cnt;
	int					hist_sz;
	char				hist_item[ 80 ];

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Which item is selected ? Get nb and position ---*/
	if ( cbinfo->reason_subtype != Pt_LIST_SELECTION_FINAL )
		return( Pt_CONTINUE );

	/*--- Reset the game ---*/
	init_new_game( FALSE, FALSE );

	/*--- Bring the game to this point ---*/
	player = CODE_BLACK;
	enemy  = CODE_WHITE;
	busyWindow( ABW_phothello, TRUE );
	PtHold();
	hist_sz = getItemsCountList( ABW_phothello_history );
	for ( cnt = 1; (cnt <= infos->item_pos) && (cnt <= hist_sz); cnt++ )
		{

		/*--- Get the position ---*/
		strcpy( hist_item, getItemList( ABW_phothello_history, cnt ) );
		y = hist_item[ 12 ] - '@';
		x = hist_item[ 13 ] - '0';

		/*--- Generate all the possible move ---*/
		ptr1 = ptr2 = &possib[ 0 ];
		if ( (nb_poss = do_build_possib( &ptr2, player, enemy )) == 0 )
			{
			player = (CODE_BLACK + CODE_WHITE) - player;
			enemy  = (CODE_BLACK + CODE_WHITE) - enemy;
			ptr1 = ptr2 = &possib[ 0 ];
			if ( (nb_poss = do_build_possib( &ptr2, player, enemy )) == 0 )
				return PtRelease(), busyWindow( ABW_phothello, FALSE ), Pt_CONTINUE;
			}	// if

		/*--- Is-it a valid move ? ---*/
		for ( valid_move = FALSE, p = (UINT*)ptr1, p++; p != ptr2; )
			{
			if ( (UBYTE*)*p++ == &board[ XY(x, y)] )
				{
				valid_move = TRUE;
				break;
				}
			nb_took = *p++;
			p += nb_took;
			}	// for (p)
		if ( !valid_move )
			return PtRelease(), busyWindow( ABW_phothello, FALSE ), Pt_CONTINUE;

		/*--- Play this new move ---*/
		board[ XY(x, y) ] = player;
		nb_took = *p++;
		for ( k = 0; k < nb_took; k++ )
			*(UBYTE*)*p++ = player;

		/*--- Next player ---*/
		player = (CODE_BLACK + CODE_WHITE) - player;
		enemy  = (CODE_BLACK + CODE_WHITE) - enemy;

		}	// for (cnt)

	/*--- Refresh the display ---*/
	draw_complete_board();
	compute_nb_pawns( TRUE );

	/*--- Which player next, if any ? ---*/
	ptr1 = ptr2 = &possib[ 0 ];
	if ( (nb_poss = do_build_possib( &ptr2, player, enemy )) == 0 )
		{
		ptr2 = &possib[ 0 ];
		if ( (nb_poss = do_build_possib( &ptr2, enemy, player )) == 0 )
			return PtRelease(), busyWindow( ABW_phothello, FALSE ), Pt_CONTINUE;
		player = (CODE_BLACK + CODE_WHITE) - player;
		}	// if

	/*--- Update the buttons ---*/
	if ( player == code_computer )
		{
		PtUnrealizeWidget( ABW_phothello_btn_human_turn );
		PtRealizeWidget( ABW_phothello_btn_computer_turn );
		PtContainerGiveFocus( ABW_phothello_btn_computer_turn, cbinfo->event );
		show_poss_play_cursor( code_computer, code_human );
		}
	else
		{
		PtUnrealizeWidget( ABW_phothello_btn_computer_turn );
		PtRealizeWidget( ABW_phothello_btn_human_turn );
		PtContainerGiveFocus( ABW_phothello_btn_human_turn, cbinfo->event );
		show_poss_play_cursor( code_human, code_computer );
		}

	return PtRelease(), busyWindow( ABW_phothello, FALSE ), Pt_CONTINUE;

	}	// history_selection
