; ----------------------------------------------------------------
;
; 
;
; ----------------------------------------------------------------

		.386p


; Defined into the C module
extrn	_board:	byte	100;

global 	nb_possib_:	proc


; ----------------
; Clear a register
; ----------------
clr		macro	reg
		xor		reg, reg
		endm


; -----------------------------
; Local variable to this module
; -----------------------------

_DATA	segment para public use32

ptr_table_possib	dd	0		; Pointer into the table of the game possibilities

save_edi			dd	0

_DATA	ends
	

_TEXT	segment para public use32
		assume cs:code32, ds:code32, ss:code32

; ---------------------------------------------------------------------------------------------
; Argument of the macro is:
;	dir_ofs (-11, -10, -9, -1, +1, +9, +10, +11)
;
; 		ESI:	pointer to the table of the possibilities
;		EDI:	pointer to the case to analyse
;		DL:		code for the player's pawn (stored into DL)
;		DH:		code for the enemy's pawn  (stored into DH)
; ---------------------------------------------------------------------------------------------
check_dir			macro	dir_ofs
		
					local	scan_enemy, scan_enemy_end, record_enemy, record_enclosed, scan_next_dir

					mov		esi, ebp				; Pointer to each cells scanned
					clr		ah						; Enemy enclosed counter

scan_enemy:			add		esi, dir_ofs
					mov		al, [esi]
					cmp		al, dh					; Enemy pawn ?
					jne		scan_enemy_end
					inc		ah						; One enemy more
					jmp		scan_enemy

scan_enemy_end:		or		ah, ah					; At least one enemy ?
					jz		scan_next_dir			; Go to scan next direction

					; Is there into the last case a pawn of the player ?
					cmp		al, dl
					jne		scan_next_dir			; No: then scan direction


record_enemy:
					; Cumulate the nb of pawns took
					add		bl, ah

scan_next_dir:					

					endm


; ---------------------------------------------------------------------------------------------
; I)	EAX:	code for the player's pawn (stored into DL)
;		EBX:	code for the enemy's pawn  (stored into DH)
; O)	EAX:	nb of possibilities
; ---------------------------------------------------------------------------------------------

nb_possib_		proc

					; Save some vital registers, used by C-Runtime
					push	ebp

					; Store the codes of the player and the enemy
					mov		dl, al
					mov		dh, bl

					; Counter of possibilities
					clr		bh

					; Scan each empty cell of the board
					lea		ebp, _board + 11
					mov		cl, 78
next_cell:			test	byte ptr [ebp], 0FFh
					jne		cell_done				; Cell non empty, skip

					clr		bl						; Count the nb of pawns took

					check_dir	-11
					check_dir	-10
					check_dir	-9
					check_dir	-1
					check_dir	1
					check_dir	9
					check_dir	10
					check_dir	11

					or		bl, bl
					jz		cell_done
					inc		bh
cell_done:
				
					inc		ebp
					dec		cl
					jne		next_cell	
					
					; Value to return (nb of possibilities)
					movzx	eax, bh

					; Restore some vital registers, used by C-Runtime
					pop		ebp

					ret
nb_possib_		endp

_TEXT		ends
			end
