/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "phothello.h"
#include "abimport.h"
#include "proto.h"


int
options_changeside( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	int			tmp;
	int			nb_poss;

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Dimiss all possible messages ---*/
	PtUnrealizeWidget( ABW_phothello_btn_human_pass );
	PtUnrealizeWidget( ABW_phothello_btn_human_cancel );
	PtUnrealizeWidget( ABW_phothello_btn_human_turn );
	PtUnrealizeWidget( ABW_phothello_btn_computer_pass );
	PtUnrealizeWidget( ABW_phothello_btn_computer_turn );

	/*--- Stop the current clock ---*/
	stop_count_time();

	/*--- By default, computer has black, play has white ---*/
	tmp = code_computer;
	code_computer = code_human;
	code_human    = tmp;

	/*--- Label ---*/
	if ( code_computer == CODE_BLACK )
		{
		setString( ABW_phothello_who_black, "Computer:" );
		setString( ABW_phothello_who_white, "Player:" );
		}
	else
		{
		setString( ABW_phothello_who_black, "Player:" );
		setString( ABW_phothello_who_white, "Computer:" );
		}

	/*--- Update the infos on the window ---*/
	setString( ABW_phothello_msg, "" );
	if ( color_to_play == code_computer )
		{

		/*--- Show the possibilities for the computer ---*/
		nb_poss = show_poss_play_cursor( code_computer, code_human );

		/*--- How many possibilities for the computer ? ---*/
		if ( nb_poss == 0 )
			{
			PtRealizeWidget( ABW_phothello_btn_computer_pass );
			PtContainerGiveFocus( ABW_phothello_btn_computer_pass, cbinfo->event );
			}
		else
			{
			PtRealizeWidget( ABW_phothello_btn_computer_turn );
			PtContainerGiveFocus( ABW_phothello_btn_computer_turn, cbinfo->event );
			}

		/*--- Stop the current clock ---*/
		stop_count_time();

		}	// if
	else
		{

		/*--- Update the cursors into the grid, depending the game possibilities ---*/
		if ( show_poss_play_cursor( code_human, code_computer ) == 0 )
			{
			PtRealizeWidget( ABW_phothello_btn_human_pass );
			PtContainerGiveFocus( ABW_phothello_btn_human_pass, cbinfo->event );
			}
		else
			{
			PtRealizeWidget( ABW_phothello_btn_human_turn );
			PtContainerGiveFocus( ABW_phothello_btn_human_turn, cbinfo->event );
			}
		
		/*--- Start the clock for the current player ---*/
		start_count_time( color_to_play );

		}	// else

#if LOGTOTMP==1
	slog( "changes side", getlogin() );
#endif

	return( Pt_CONTINUE );

	}	// options_changeside


int
options_settings( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Mount the dialog ---*/
	if ( ABW_settings == NULL )
		ApCreateModule( ABM_settings, NULL, NULL );
	else
		window_focus( ABW_settings );

	return( Pt_CONTINUE );

	}	// options_settings


int
options_suggestmove( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	WHERE_TO_PLAY	where_to_play;

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- The computer plays... ---*/
	computer_play( &where_to_play, 
		color_to_play, (CODE_BLACK+CODE_WHITE)-color_to_play, TRUE );

	return( Pt_CONTINUE );

	}	// options_suggestmove
