/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "phothello.h"
#include "abimport.h"
#include "proto.h"


int
rules_setup( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	link_instance = link_instance, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Set the Position/Size of the window if given in the .ini file ---*/
	readandset_cfg_szpos( "Rules window", ABW_rules );

	return( Pt_CONTINUE );

	}	// rules_setup


int
rules_destroyed( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Save position and dimension of this window into the config (life.ini) file ---*/
	save_posdim_in_config_file( "Rules window", ABW_rules );

	/*--- Dialog not mounted ---*/
	ABW_rules = NULL;

	return( Pt_CONTINUE );

	}	// rules_destroyed


int
rules_resize( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	USHORT		w, h;

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Compute the difference ---*/
	getDim( ABW_rules, &w, &h );

	/*--- Resize (in height only) the scroll area ---*/
	w -= 12;
	h -= 16;
	setDim( ABW_rules_scrollarea, w, h );

	return( Pt_CONTINUE );

	}	// rules_resize
