/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "phothello.h"
#include "abimport.h"
#include "proto.h"


int
settings_setup( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	link_instance = link_instance, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Set the level ---*/
	switch ( options.level )
		{
		case LEVEL1 : setBtn( ABW_settings_level1, TRUE ); break;
		case LEVEL2 : setBtn( ABW_settings_level2, TRUE ); break;
		case LEVEL3 : setBtn( ABW_settings_level3, TRUE ); break;
		case LEVEL4 : setBtn( ABW_settings_level4, TRUE ); break;
		}	// switch

	/*--- Set the strategy ---*/
	if ( (options.strategy >= 1) && (options.strategy <= 6) )
		setBtn( dssettings[ ABN_settings_strategy + options.strategy ].wgt, TRUE );
	else
		setBtn( dssettings[ ABN_settings_strategy1 ].wgt, TRUE );

	/*--- Set the Position/Size of the window if given in the .ini file ---*/
	readandset_cfg_szpos( "Settings window", ABW_settings );

	return( Pt_CONTINUE );

	}	// settings_setup


int
settings_destroyed( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Save position and dimension of this window into the config (life.ini) file ---*/
	save_posdim_in_config_file( "Settings window", ABW_settings );

	/*--- This dialog is no more mounted ---*/
	ABW_settings = NULL;

	return( Pt_CONTINUE );

	}	// settings_destroyed


int
settings_ok( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	/*--- Get level ---*/
	if ( isBtnSet( ABW_settings_level1 ) )		options.level = LEVEL1;
	else if ( isBtnSet( ABW_settings_level2 ) )	options.level = LEVEL2;
	else if ( isBtnSet( ABW_settings_level3 ) )	options.level = LEVEL3;
	else if ( isBtnSet( ABW_settings_level4 ) )	options.level = LEVEL4;
	else										options.level = LEVEL1;

	/*--- Set the strategy ---*/
	for ( options.strategy = 0; options.strategy < 6; )
		if ( isBtnSet( dssettings[ ABN_settings_strategy + ++options.strategy ].wgt ) )
			break;

	/*--- Close the window ---*/
	PtDestroyWidget( ABW_settings );

	return( Pt_CONTINUE );

	}	// settings_ok
